HOST = "47.75.4.252"
PORT = 10002

menu = 'Welcome to Sixstars Secret Storage Service\nCommands:\n\tset [key]\tstore a secret with given key\n\tget [key]\tget a secret with given key\n'


from pwn import *
import string

def solve_PoW(suffix, h):
    print "solving PoW......"
    charset = string.letters + string.digits

    for p1 in charset:
        for p2 in charset:
            for p3 in charset:
                for p4 in charset:
                    plaintext = p1 + p2+ p3+ p4 + suffix
                    m = hashlib.sha256()
                    m.update(plaintext)
                    if m.hexdigest() == h:
                        print "PoW solution has been found!"
                        return p1+p2+p3+p4 


def encrypt(msg):
    global keystream
    keystream = keystream[16:]
    
    plain = pad(msg)
    assert(len(keystream) >= len(plain))
    k = keystream[:len(plain)]
    
    return xor(plain, k)
    
def decrypt(cipher):
    global keystream
    keystream = keystream[16:]
    assert(len(keystream) >= len(cipher))
    
    k = keystream[:len(cipher)]
    plain = xor(cipher, k)
    msg = plain[:-ord(plain[-1])] #remove padding from message
    return msg

def pad(msg):
    pad = 16 - len(msg)%16
    plain = msg + chr(pad)*pad
    return plain


#connect to the server and solve proof of work
r = remote(HOST, PORT) 
data = r.recvuntil("Give me XXXX:")
suffix = re.findall(r"XXXX\+([^\)]+)",data)[0]
h = re.findall(r"== ([0-9a-f]+)",data)[0]
p = solve_PoW(suffix, h)
r.send(p)


#phase 1 - get enough bytes of keystream
r.send("\x00"+"a"*16)
hash_and_mac = r.recv()[1:]
r.send("\x01"+hash_and_mac)
r.recv() #receive not important stuff

#get encrypted known plaintext
encrypted_data = r.recv()
known_plaintext = pad("\x02" + menu)
keystream = KEYSTREAM = xor(known_plaintext, encrypted_data)

#set kk to a known long value
r.send(encrypt("\x02set kk"))
decrypt(r.recv()) # "value?"
kk = "\x02"+"a"*(len(keystream)-5-16)
r.send(encrypt(kk))
decrypt(r.recv()) #"\x02OK"

#get new portion of a keystream
r.send(encrypt("\x02get kk"))
data = r.recv()
new_keystream = xor(data, pad(kk))
KEYSTREAM += new_keystream[-16*3:]
keystream += new_keystream[-16*3:]
keystream = keystream[16:]

#get new portion of a keystream
r.send(encrypt("\x02get kk"))
data = r.recv()
new_keystream = xor(data, pad(kk))
KEYSTREAM += new_keystream[-16*2:]


r.close()

#phase 2 - read the flag, we have enough keystream now

#connect to the server and solve proof of work
r = remote(HOST, PORT) 
data = r.recvuntil("Give me XXXX:")
suffix = re.findall(r"XXXX\+([^\)]+)",data)[0]
h = re.findall(r"== ([0-9a-f]+)",data)[0]
p = solve_PoW(suffix, h)
r.send(p)

r.send("\x00"+"a"*16)
hash_and_mac = r.recv()[1:]
r.send("\x01"+hash_and_mac)
r.recv() #receive not important stuff


r.recv()

keystream = KEYSTREAM

#get the flag
r.send(encrypt("\x02get flag"))

encrypted_flag = r.recv()
print xor(encrypted_flag, keystream[16:])
 
